import type { TokenValueFunction } from '@/lib/util';
export declare class CookieOptions {
    domain: string;
    httpOnly: boolean;
    maxAge: number | undefined;
    name: string;
    path: string;
    sameSite: boolean | 'none' | 'strict' | 'lax';
    secure: boolean;
    constructor(opts?: Partial<CookieOptions>);
}
export declare class TokenOptions {
    responseHeader: string;
    value: TokenValueFunction | undefined;
    constructor(opts?: Partial<TokenOptions>);
}
export declare class Config {
    cookie: CookieOptions;
    excludePathPrefixes: string[];
    ignoreMethods: string[];
    saltByteLength: number;
    secretByteLength: number;
    token: TokenOptions;
    constructor(opts?: Partial<ConfigOptions>);
}
export interface ConfigOptions extends Omit<Config, 'cookie' | 'token'> {
    cookie: Partial<CookieOptions>;
    token: Partial<TokenOptions>;
}
