import { CsrfError as d } from "./errors.js";
import { createSecret as w, utoa as a, atou as c, getTokenString as m, verifyToken as y, createToken as p } from "./util.js";
class h {
  constructor(t) {
    this.domain = "", this.httpOnly = !0, this.maxAge = void 0, this.name = "_csrfSecret", this.path = "/", this.sameSite = "strict", this.secure = !0, Object.assign(this, t);
  }
}
class f {
  constructor(t) {
    this.value = void 0, Object.assign(this, t);
  }
}
class B {
  constructor(t) {
    this.excludePathPrefixes = [], this.ignoreMethods = ["GET", "HEAD", "OPTIONS"], this.saltByteLength = 8, this.secretByteLength = 18, this.cookie = new h(), this.token = new f();
    const e = t || {};
    if (e.cookie && (e.cookie = new h(e.cookie)), e.token && (e.token = new f(e.token)), Object.assign(this, e), this.saltByteLength < 1 || this.saltByteLength > 255)
      throw Error("saltBytLength must be greater than 0 and less than 256");
    if (this.secretByteLength < 1 || this.secretByteLength > 255)
      throw Error("secretBytLength must be greater than 0 and less than 256");
  }
}
function O(o) {
  const t = new B(o || {});
  return async (e) => {
    const { request: i, url: g, getCookie: u, setCookie: l } = e;
    for (const r of t.excludePathPrefixes)
      if (g.pathname.startsWith(r))
        return;
    const n = u(t.cookie.name);
    let s;
    if (n === void 0 ? (s = w(t.secretByteLength), l({ ...t.cookie, value: a(s) })) : s = c(n), !t.ignoreMethods.includes(i.method)) {
      const r = await m(i, t.token.value);
      if (!await y(c(r), s))
        throw new d("csrf validation error");
    }
    const k = await p(s, t.saltByteLength);
    return a(k);
  };
}
export {
  B as Config,
  h as CookieOptions,
  f as TokenOptions,
  O as createCsrfProtect
};
